
<?php
    
    function decodeSTRING($val){
        // #, &, +  < > などが URI 送信で化けるため encode して送られたものを decode
        $array = explode("%x0;", $val);
        $val = implode("#", $array);
        $array = explode("%x1;", $val);
        $val = implode("&", $array);
        $array = explode("%x2;", $val);
        $val = implode("+", $array);
        $array = explode("%x3;", $val);
        $val = implode("<", $array);
        $array = explode("%x4;", $val);
        $val = implode(">", $array);
        $array = explode("%x5;", $val);
        $val = implode(" ", $array);
        $array = explode("%x6;", $val);
        $val = implode("\\n", $array);
        $array = explode("%x7;", $val);
        $val = implode("\"", $array);
        $array = explode("%x8;", $val);
        $val = implode("$", $array);
        return $val;
    }
    
    function leftBrackets(){
        // $leftBrackets = "\^\[\^" では誤作動
        //	return "\^\[\^"; // encode 中で使う '(' -- クライアント側との約束 lib.js
        return "^[^"; // encode 中で使う '(' -- クライアント側との約束 lib.js
    }
    function rightBrackets(){
        return "^]^"; // encode 中で使う '(' -- クライアント側との約束 lib.js
        //	return "\^\]\^"; // encode 中で使う '(' -- クライアント側との約束 lib.js
    }
    function decodeObject($buff){
        // "key(value)" 形式の文字列を OBJECT に decode して返す
        $obj = array();
        //	echo "decodeObject ===\n$buff\n"; //##
        for ($p=$begin=$nest=0, $len=strlen($buff); $p < $len; $p++){
            $ch = substr($buff, $p, 1);
            if (strcmp($ch, "(") == 0){
                if ($nest == 0){
                    $key = trim(substr($buff, $begin, $p - $begin)); // key 終端
                    $begin = $p + 1; // value 開始位置
                }
                $nest++;
            } else if (strcmp($ch, ")") == 0){
                if (--$nest == 0){
                    if ($nest == 0){
                        // value 終端 ( trim しない )
                        $value = substr($buff,$begin,$p-$begin);
                        $begin = $p + 1; // key 開始位置
                    }
                    if (ereg(")", $value)){ // まだ入れ子になっているなら
                        $obj[$key] = decodeObject($value);
                    } else {
                        // 特定文字を "(", ")" へ戻す
                        $array = explode(leftBrackets(), $value);
                        $value = join("(", $array);
                        $array = explode(rightBrackets(), $value);
                        $value = join(")", $array);
                        
                        $obj[$key] = $value;
                    }
                    //echo "$key{".$obj[$key]."}\n"; //##
                }
            }
        }
        return $obj;
    }
    
    function timestamp(){
        // 現在のタイムスタンプを返す updateTime に使う
        date_default_timezone_set("Asia/Tokyo");
        return date("Y-m-d H:i:s",time());
    }
    
    
    
    $command=$_GET['command']; $command=htmlspecialchars($command);
    $value = $_GET['value']; $value=htmlspecialchars($value);
    $value = decodeSTRING($value); // lib.php
    
    // DB を開いて該当レコードを読み込む
    // ### セキュリティーを保つには、以下のファイルを外からアクセスできない
    // ### directory に置き、以下の cfg.php の pass をそこへ変更
    require_once('../NOA/cfg.php');
    
    $dbc = mysql_connect($db['host'], $db['user'], $db['pwd']);
    $db_select=mysql_select_db($db['dbname']);
    mysql_query("set names utf8");
    
    if (strcmp($command, "GET_LIST") == 0){
        // code に合致した薬剤名リストを返す(約束処方も含む)
        $code = $value;
        $query="SELECT * FROM `PriceList` WHERE `code` LIKE '%$code%' ORDER BY `alias`";
        $result=mysql_query($query);
        echo "$sql \n"; //##
        
        $array = array();
        while ($row=mysql_fetch_array($result)){
            $array[] = array(
                             'code'=>$row['code'],'alias'=>$row['alias'],'name'=>$row['name'],'generic'=>$row['generic'],
                             'point'=>$row['point'],'unit'=>$row['unitName'],'handan'=>$row['handan'],
                             'min'=>$row['min'],'standard'=>$row['standard'],'max'=>$row['max'],
                             'width'=>$row['width'],'effect'=>$row['effect'],'memo'=>$row['memo']
                             );
        }

        echo "<SEPARATOR>";
        echo json_encode($array);
    } else if (strcmp($command, "GET_FILE") == 0){
        $filename = $value;
        
        echo "<SEPARATOR>";
        echo "../Medicine/medicine/$filename";
    } else if (strcmp($command, "GET_PRICE_LIST") == 0){
        // code, name に一致したものをリストアップ
        $sql = "SELECT * FROM `PriceList` WHERE `code` LIKE '2%' AND `name` LIKE '%$value%' ORDER BY `name`";
        $result=mysql_query($sql);
        echo "$sql \n";
        
        $array = array();
        while ($row=mysql_fetch_array($result)){
            $array[] = $row;
        }
        
        echo "<SEPARATOR>";
        echo json_encode($array);
    } else if (strcmp($command, "PUT_PRICE_LIST") == 0){
        // PriceList に薬剤レコードをマージ
        $args = decodeObject($value);
        $code = $args['code'];
        $requestCode = $args['requestCode'];
        $alias = $args['alias'];
        $name = $args['name'];
        $point = $args['point'];
        $unitName = $args['unitName'];
        $min = $args['min'];
        $standard = $args['standard'];
        $max = $args['max'];
        $width = $args['width'];
        $effectCode = $args['effectCode'];
        $effect = $args['effect'];
        $memo = $args['memo'];
        $updateTime = timestamp();
        
        $sql = "SELECT * FROM `PriceList` WHERE `code`LIKE'%$code%' AND `name`='$name'";
        echo "$sql ------\n";
        $result=mysql_query($sql);
        
        $_alias = (strlen($alias)) ? ",`alias`='$alias'" : "";
        $_min = (strlen($min)) ? ",`min`='$min'" : "";
        $_standard = (strlen($standard)) ? ",`standard`='$standard'" : "";
        $_max = (strlen($max)) ? ",`max`='$max'" : "";
        $_width = (strlen($width)) ? ",`width`='$width'" : "";
        $_effect = (strlen($effect)) ? ",`effect`='$effect'" : "";
        $_memo = (strlen($memo)) ? ",`memo`='$memo'" : "";
        
        if (mysql_num_rows ($result)){
            $sql = "UPDATE `PriceList` SET
            `requestCode`='$requestCode'
            $_alias
            ,`point`='$point'
            ,`unitName`='$unitName'
            $_min
            $_standard
            $_max
            $_width
            ,`effectCode`='$effectCode' $_effect $_memo
            ,`updateTime`='$updateTime'
            WHERE `code`='$code' AND `name`='$name'";
        } else {
            $sql = "INSERT INTO `PriceList`
            (`code`,`requestCode`,`alias`,`name`,`point`,`unitName`
             ,`handan`,`min`,`standard`,`max`,`width`,`effectCode`
             ,`effect`,`memo`,`updateTime`) 
            VALUES 
            ('$code',$requestCode,'$alias','$name','$point','$unitName'
             ,'','$min','$standard','$max','$width','$effectCode'
             ,'$effect','$memo','$updateTime')";
        }
        mysql_query($sql);
        echo "$sql ------\n";
        echo "<SEPARATOR>";
        echo $value;
    } else {
        echo "*** unknown command: $command ***";
    }
    
?>
